diff --git a/src/text.c b/src/text.c
index 254de7f2..dd3230b3 100644
--- a/src/text.c
+++ b/src/text.c
@@ -2211,15 +2211,6 @@ void do_justify(bool full_justify)
 	char *the_lead = mallocstrcpy(NULL, "");
 	size_t lead_len = 0;
 
-	/* We need these to hold the leading part of the line after the line where
-	 * the marked text begins (if any). */
-	char *the_second_lead = NULL;
-	size_t second_lead_len = 0;
-
-	/* How many characters we need to add to the beginning of the marked text,
-	 * in order to get a full leading part there. */
-	size_t needed_extra = 0;
-
 	/* Whether the bottom of the mark is at the end of its line, in which case
 	 * we don't need to add a new line after it. */
 	bool ends_at_eol = FALSE;
@@ -2276,25 +2267,6 @@ void do_justify(bool full_justify)
 		the_lead = mallocstrncpy(the_lead, first_par_line->data, lead_len + 1);
 		the_lead[lead_len] = '\0';
 
-		/* Copy the leading part that is to be used for the new paragraph after
-		 * its first line (if any): the quoting of the first line, plus the
-		 * indentation of the second line. */
-		if (first_par_line != last_par_line) {
-			filestruct *sampleline = first_par_line->next;
-			size_t sample_quote_len = quote_length(sampleline->data);
-			size_t sample_indent_len = indent_length(sampleline->data + sample_quote_len);
-
-			second_lead_len = quote_len + sample_indent_len;
-			the_second_lead = charalloc(second_lead_len + 1);
-			strncpy(the_second_lead, first_par_line->data, quote_len);
-			strncpy(the_second_lead + quote_len, sampleline->data + sample_quote_len,
-					sample_indent_len);
-			the_second_lead[second_lead_len] = '\0';
-		/* If there is no second line, use the leading part of the first line. */
-		} else {
-			the_second_lead = strdup(the_lead);
-			second_lead_len = lead_len;
-		}
 	} else
 #endif
 	{
@@ -2340,37 +2312,19 @@ void do_justify(bool full_justify)
 	update_undo(CUT);
 
 	if (openfile->mark) {
-		size_t line_len = strlen(cutbuffer->data);
-		size_t indent_len;
 		filestruct *line;
 
-		needed_extra = (top_x < lead_len ? top_x : lead_len);
-
-		/* If the marked region starts in the middle of a line, and this line
-		 * has a leading part, prepend any missing portion of this leading part
-		 * to the first line of the extracted region. */
-		if (needed_extra > 0) {
-			cutbuffer->data = charealloc(cutbuffer->data,
-									line_len + needed_extra + 1);
-			charmove(cutbuffer->data + needed_extra, cutbuffer->data,
-									line_len + 1);
-			strncpy(cutbuffer->data, the_lead, needed_extra);
-			line_len += needed_extra;
-		}
-
-		indent_len = indent_length(cutbuffer->data + lead_len);
-
-		/* Remove extra whitespace after the leading part. */
-		if (indent_len > 0)
-			charmove(cutbuffer->data + lead_len,
-						cutbuffer->data + lead_len + indent_len,
-						line_len - indent_len + 1);
-
 		/* Manually justify the marked region. */
 		concat_paragraph(&cutbuffer, par_len);
 		justify_format(cutbuffer, lead_len);
+
+		char *text = cutbuffer->data;
+		text = charealloc(text, strlen(text) + lead_len + 1);
+		charmove(text + lead_len, text, strlen(text) + 1);
+		strncpy(text, the_lead, lead_len);
+
 		line = cutbuffer;
-		rewrap_paragraph(&line, the_second_lead, second_lead_len);
+		rewrap_paragraph(&line, the_lead, lead_len);
 		cutbottom = line;
 
 		/* If the marked region started after the beginning of a line, separate
@@ -2379,9 +2333,9 @@ void do_justify(bool full_justify)
 		 * (now-redundant) portions of the leading part that we prepended to it
 		 * earlier, and it will be the new line. */
 		if (top_x > 0) {
-			if (needed_extra > 0 && top_x <= lead_len)
-				charmove(cutbuffer->data, cutbuffer->data + needed_extra,
-							strlen(cutbuffer->data) - needed_extra + 1);
+			if (top_x <= lead_len)
+				charmove(cutbuffer->data, cutbuffer->data + top_x,
+							strlen(cutbuffer->data) - top_x + 1);
 			else {
 				cutbuffer->prev = make_new_node(NULL);
 				cutbuffer->prev->data = mallocstrcpy(NULL, "");
@@ -2399,7 +2353,6 @@ void do_justify(bool full_justify)
 		}
 
 		free(the_lead);
-		free(the_second_lead);
 	} else
 #endif
 	{
